//----------------------------------------------------------------------------
// AdvSpin.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: AdvSpin.pas
//----------------------------------------------------------------------------
#ifndef AdvSpinHPP
#define AdvSpinHPP
//----------------------------------------------------------------------------
#include <Mask.hpp>
#include <Dialogs.hpp>
#include <Buttons.hpp>
#include <Menus.hpp>
#include <Graphics.hpp>
#include <Forms.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Controls.hpp>
#include <ExtCtrls.hpp>
#include <StdCtrls.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Advspin
{
//-- type declarations -------------------------------------------------------
typedef Buttons::TNumGlyphs TNumGlyphs;

class __declspec(delphiclass) TWinCtrl;
class __declspec(pascalimplementation) TWinCtrl : public Controls::TWinControl
{
	typedef Controls::TWinControl inherited;
	
public:
	/* TWinControl.Create */ __fastcall virtual TWinCtrl(Classes::TComponent* AOwner) : Controls::TWinControl(
		AOwner) { }
	/* TWinControl.CreateParented */ __fastcall TWinCtrl(HWND ParentWindow) : Controls::TWinControl(ParentWindow
		) { }
	/* TWinControl.Destroy */ __fastcall virtual ~TWinCtrl(void) { }
	
};

enum TSpinDirection { spVertical, spHorizontal };

enum TLabelPosition { lpLeftTop, lpLeftCenter, lpLeftBottom, lpTopLeft, lpBottomLeft, lpLeftTopLeft, 
	lpLeftCenterLeft, lpLeftBottomLeft, lpTopCenter, lpBottomCenter };

class __declspec(delphiclass) TAdvSpinButton;
class __declspec(delphiclass) TAdvTimerSpeedButton;
enum AdvSpin_5 { tbFocusRect, tbAllowTimer };

typedef Set<AdvSpin_5, tbFocusRect, tbAllowTimer>  TTimeBtnState;

enum TButtonDirection { bdLeft, bdRight, bdUp, bdDown };

class __declspec(pascalimplementation) TAdvTimerSpeedButton : public Buttons::TSpeedButton
{
	typedef Buttons::TSpeedButton inherited;
	
private:
	Extctrls::TTimer* FRepeatTimer;
	TTimeBtnState FTimeBtnState;
	TButtonDirection FButtonDirection;
	void __fastcall TimerExpired(System::TObject* Sender);
	
protected:
	virtual void __fastcall Paint(void);
	virtual void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	virtual void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int 
		Y);
	
public:
	__fastcall virtual ~TAdvTimerSpeedButton(void);
	__property TTimeBtnState TimeBtnState = {read=FTimeBtnState, write=FTimeBtnState, nodefault};
	__property TButtonDirection ButtonDirection = {read=FButtonDirection, write=FButtonDirection, nodefault
		};
public:
	/* TSpeedButton.Create */ __fastcall virtual TAdvTimerSpeedButton(Classes::TComponent* AOwner) : Buttons::
		TSpeedButton(AOwner) { }
	
};

class __declspec(pascalimplementation) TAdvSpinButton : public Controls::TWinControl
{
	typedef Controls::TWinControl inherited;
	
private:
	TAdvTimerSpeedButton* FUpButton;
	TAdvTimerSpeedButton* FDownButton;
	TAdvTimerSpeedButton* FFocusedButton;
	Controls::TWinControl* FFocusControl;
	Classes::TNotifyEvent FOnUpClick;
	Classes::TNotifyEvent FOnDownClick;
	TSpinDirection FDirection;
	TAdvTimerSpeedButton* __fastcall CreateButton(void);
	Graphics::TBitmap* __fastcall GetUpGlyph(void);
	Graphics::TBitmap* __fastcall GetDownGlyph(void);
	void __fastcall SetUpGlyph(Graphics::TBitmap* Value);
	void __fastcall SetDownGlyph(Graphics::TBitmap* Value);
	Buttons::TNumGlyphs __fastcall GetUpNumGlyphs(void);
	Buttons::TNumGlyphs __fastcall GetDownNumGlyphs(void);
	void __fastcall SetUpNumGlyphs(Buttons::TNumGlyphs Value);
	void __fastcall SetDownNumGlyphs(Buttons::TNumGlyphs Value);
	void __fastcall BtnClick(System::TObject* Sender);
	void __fastcall BtnMouseDown(System::TObject* Sender, Controls::TMouseButton Button, Classes::TShiftState 
		Shift, int X, int Y);
	void __fastcall SetFocusBtn(TAdvTimerSpeedButton* Btn);
	void __fastcall SetDirection(const TSpinDirection Value);
	void __fastcall AdjustSize(int &W, int &H);
	HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	HIDESBASE MESSAGE void __fastcall WMSetFocus(Messages::TWMSetFocus &Message);
	HIDESBASE MESSAGE void __fastcall WMKillFocus(Messages::TWMKillFocus &Message);
	MESSAGE void __fastcall WMGetDlgCode(Messages::TWMNoParams &Message);
	
protected:
	virtual void __fastcall Loaded(void);
	virtual void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	
public:
	__fastcall virtual TAdvSpinButton(Classes::TComponent* AOwner);
	virtual void __fastcall SetBounds(int ALeft, int ATop, int AWidth, int AHeight);
	
__published:
	__property Align ;
	__property Ctl3D ;
	__property TSpinDirection Direction = {read=FDirection, write=SetDirection, nodefault};
	__property Graphics::TBitmap* DownGlyph = {read=GetDownGlyph, write=SetDownGlyph, nodefault};
	__property Buttons::TNumGlyphs DownNumGlyphs = {read=GetDownNumGlyphs, write=SetDownNumGlyphs, default=1
		};
	__property DragCursor ;
	__property DragMode ;
	__property Enabled ;
	__property Controls::TWinControl* FocusControl = {read=FFocusControl, write=FFocusControl, nodefault
		};
	__property ParentCtl3D ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ShowHint ;
	__property TabOrder ;
	__property TabStop ;
	__property Graphics::TBitmap* UpGlyph = {read=GetUpGlyph, write=SetUpGlyph, nodefault};
	__property Buttons::TNumGlyphs UpNumGlyphs = {read=GetUpNumGlyphs, write=SetUpNumGlyphs, default=1}
		;
	__property Visible ;
	__property Classes::TNotifyEvent OnDownClick = {read=FOnDownClick, write=FOnDownClick};
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnStartDrag ;
	__property Classes::TNotifyEvent OnUpClick = {read=FOnUpClick, write=FOnUpClick};
public:
	/* TWinControl.CreateParented */ __fastcall TAdvSpinButton(HWND ParentWindow) : Controls::TWinControl(
		ParentWindow) { }
	/* TWinControl.Destroy */ __fastcall virtual ~TAdvSpinButton(void) { }
	
};

enum TAdvSpinType { sptNormal, sptFloat, sptDate, sptTime, sptHex };

class __declspec(delphiclass) TAdvSpinEdit;
class __declspec(pascalimplementation) TAdvSpinEdit : public Mask::TCustomMaskEdit
{
	typedef Mask::TCustomMaskEdit inherited;
	
private:
	bool FFlat;
	Graphics::TColor FFlatLineColor;
	Stdctrls::TLabel* FLabel;
	Graphics::TFont* FLabelFont;
	TLabelPosition FLabelPosition;
	int FLabelMargin;
	bool FLabelTransparent;
	long FMinValue;
	long FMaxValue;
	double FMinFloatValue;
	double FMaxFloatValue;
	System::TDateTime FMinDateValue;
	System::TDateTime FMaxDateValue;
	System::TDateTime FDateValue;
	System::TDateTime FTimeValue;
	long FHexValue;
	long FIncrement;
	double FIncrementFloat;
	long FIncrementPage;
	double FIncrementFloatPage;
	bool FIncrementSmart;
	TAdvSpinButton* FButton;
	bool FEditorEnabled;
	TSpinDirection FDirection;
	TAdvSpinType FSpinType;
	int FPrecision;
	bool FReturnIsTab;
	bool FTransparent;
	int __fastcall GetMinHeight(void);
	long __fastcall GetValue(void);
	long __fastcall CheckValue(long NewValue);
	void __fastcall SetValue(long NewValue);
	double __fastcall GetFloatValue(void);
	double __fastcall CheckFloatValue(double NewValue);
	System::TDateTime __fastcall CheckDateValue(System::TDateTime NewValue);
	void __fastcall SetFloatValue(double NewValue);
	void __fastcall SetEditRect(void);
	void __fastcall SetEditorEnabled(bool NewValue);
	void __fastcall SetDirection(const TSpinDirection Value);
	void __fastcall SetPrecision(const int Value);
	void __fastcall SetSpinType(const TAdvSpinType Value);
	System::TDateTime __fastcall GetTimeValue(void);
	void __fastcall SetTimeValue(const System::TDateTime Value);
	System::TDateTime __fastcall GetDateValue(void);
	void __fastcall SetDateValue(const System::TDateTime Value);
	int __fastcall GetHexValue(void);
	void __fastcall SetHexValue(const int Value);
	HIDESBASE MESSAGE void __fastcall CNCommand(Messages::TWMCommand &Message);
	MESSAGE void __fastcall CNCtlColorEdit(Messages::TWMCtlColor &Message);
	MESSAGE void __fastcall CNCtlColorStatic(Messages::TWMCtlColor &Message);
	HIDESBASE MESSAGE void __fastcall CMFontChanged(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall WMEraseBkGnd(Messages::TWMEraseBkgnd &Message);
	HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	HIDESBASE MESSAGE void __fastcall CMEnter(Messages::TWMNoParams &Message);
	HIDESBASE MESSAGE void __fastcall CMExit(Messages::TWMNoParams &Message);
	HIDESBASE MESSAGE void __fastcall WMPaste(Messages::TWMNoParams &Message);
	HIDESBASE MESSAGE void __fastcall WMCut(Messages::TWMNoParams &Message);
	HIDESBASE MESSAGE void __fastcall WMPaint(Messages::TWMPaint &Msg);
	System::AnsiString __fastcall GetLabelCaption(void);
	void __fastcall SetLabelCaption(const System::AnsiString Value);
	void __fastcall SetLabelMargin(const int Value);
	void __fastcall SetLabelPosition(const TLabelPosition Value);
	void __fastcall SetLabelTransparent(const bool Value);
	bool __fastcall GetVisible(void);
	HIDESBASE void __fastcall SetVisible(const bool Value);
	void __fastcall LabelFontChange(System::TObject* Sender);
	void __fastcall SetLabelFont(Graphics::TFont* const Value);
	void __fastcall SetTransparent(const bool Value);
	void __fastcall SetFlat(const bool Value);
	void __fastcall SetFlatRect(const bool Value);
	void __fastcall SetFlatLineColor(const Graphics::TColor Value);
	
protected:
	virtual bool __fastcall IsValidChar(char &Key);
	virtual void __fastcall UpClick(System::TObject* Sender);
	virtual void __fastcall DownClick(System::TObject* Sender);
	virtual void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	virtual void __fastcall KeyPress(char &Key);
	virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
	virtual void __fastcall CreateWnd(void);
	virtual void __fastcall Loaded(void);
	void __fastcall UpdateLabel(void);
	Stdctrls::TLabel* __fastcall CreateLabel(void);
	void __fastcall PaintEdit(void);
	
public:
	__fastcall virtual TAdvSpinEdit(Classes::TComponent* AOwner);
	__fastcall virtual ~TAdvSpinEdit(void);
	__property TAdvSpinButton* Button = {read=FButton, nodefault};
	void __fastcall IncSmart(void);
	void __fastcall DecSmart(void);
	virtual void __fastcall SetBounds(int ALeft, int ATop, int AWidth, int AHeight);
	
__published:
	__property TSpinDirection Direction = {read=FDirection, write=SetDirection, nodefault};
	__property bool ReturnIsTab = {read=FReturnIsTab, write=FReturnIsTab, nodefault};
	__property int Precision = {read=FPrecision, write=SetPrecision, nodefault};
	__property TAdvSpinType SpinType = {read=FSpinType, write=SetSpinType, nodefault};
	__property long Value = {read=GetValue, write=SetValue, nodefault};
	__property double FloatValue = {read=GetFloatValue, write=SetFloatValue};
	__property System::TDateTime TimeValue = {read=GetTimeValue, write=SetTimeValue};
	__property System::TDateTime DateValue = {read=GetDateValue, write=SetDateValue};
	__property int HexValue = {read=GetHexValue, write=SetHexValue, nodefault};
	__property bool Flat = {read=FFlat, write=SetFlat, nodefault};
	__property Graphics::TColor FlatLineColor = {read=FFlatLineColor, write=SetFlatLineColor, nodefault
		};
	__property AutoSelect ;
	__property AutoSize ;
	__property BorderStyle ;
	__property Color ;
	__property Ctl3D ;
	__property DragCursor ;
	__property DragMode ;
	__property bool EditorEnabled = {read=FEditorEnabled, write=SetEditorEnabled, default=1};
	__property Enabled ;
	__property Font ;
	__property long Increment = {read=FIncrement, write=FIncrement, default=1};
	__property double IncrementFloat = {read=FIncrementFloat, write=FIncrementFloat};
	__property long IncrementPage = {read=FIncrementPage, write=FIncrementPage, nodefault};
	__property double IncrementFloatPage = {read=FIncrementFloatPage, write=FIncrementFloatPage};
	__property bool IncrementSmart = {read=FIncrementSmart, write=FIncrementSmart, nodefault};
	__property System::AnsiString LabelCaption = {read=GetLabelCaption, write=SetLabelCaption, nodefault
		};
	__property TLabelPosition LabelPosition = {read=FLabelPosition, write=SetLabelPosition, nodefault};
		
	__property int LabelMargin = {read=FLabelMargin, write=SetLabelMargin, nodefault};
	__property bool LabelTransparent = {read=FLabelTransparent, write=SetLabelTransparent, nodefault};
	__property Graphics::TFont* LabelFont = {read=FLabelFont, write=SetLabelFont, nodefault};
	__property MaxLength ;
	__property long MaxValue = {read=FMaxValue, write=FMaxValue, nodefault};
	__property long MinValue = {read=FMinValue, write=FMinValue, nodefault};
	__property double MinFloatValue = {read=FMinFloatValue, write=FMinFloatValue};
	__property double MaxFloatValue = {read=FMaxFloatValue, write=FMaxFloatValue};
	__property System::TDateTime MinDateValue = {read=FMinDateValue, write=FMinDateValue};
	__property System::TDateTime MaxDateValue = {read=FMaxDateValue, write=FMaxDateValue};
	__property ParentColor ;
	__property ParentCtl3D ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ReadOnly ;
	__property ShowHint ;
	__property TabOrder ;
	__property TabStop ;
	__property bool Transparent = {read=FTransparent, write=SetTransparent, nodefault};
	__property bool Visible = {read=GetVisible, write=SetVisible, nodefault};
	__property OnChange ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDrag ;
public:
	/* TWinControl.CreateParented */ __fastcall TAdvSpinEdit(HWND ParentWindow) : Mask::TCustomMaskEdit(
		ParentWindow) { }
	
};

class __declspec(delphiclass) TAdvMaskSpinEdit;
class __declspec(pascalimplementation) TAdvMaskSpinEdit : public TAdvSpinEdit
{
	typedef TAdvSpinEdit inherited;
	
__published:
	__property EditMask ;
public:
	/* TAdvSpinEdit.Create */ __fastcall virtual TAdvMaskSpinEdit(Classes::TComponent* AOwner) : Advspin::
		TAdvSpinEdit(AOwner) { }
	/* TAdvSpinEdit.Destroy */ __fastcall virtual ~TAdvMaskSpinEdit(void) { }
	
public:
	/* TWinControl.CreateParented */ __fastcall TAdvMaskSpinEdit(HWND ParentWindow) : Advspin::TAdvSpinEdit(
		ParentWindow) { }
	
};

//-- var, const, procedure ---------------------------------------------------
//-- template instantiations -------------------------------------------------
template class TTimeBtnState ;

}	/* namespace Advspin */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Advspin;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// AdvSpin
